if(this.displayCodeBlock) {
	var extension = this;
	
	extension.notice = function(str) {
		if(str) {
			str = "<div id='dialog_header'>" + str + "</div><div id='dialog_footer'><input type='button' value=' 확인 ' id='errorbtn' class='orangeBtn'></div>";
			interfacebg_on(str, 500, "#c4558c");
			$("#errorbtn").focus();
			$("#errorbtn").bind("click", interfacebg_off);
		}
	};
	
	function HamsterRobot() {
		var self = this;
		var sensory = {
			map: 0,
			signalStrength: 0,
			leftProximity: 0,
			rightProximity: 0,
			leftFloor: 0,
			rightFloor: 0,
			accelerationX: 0,
			accelerationY: 0,
			accelerationZ: 0,
			light: 0,
			temperature: 0,
			inputA: 0,
			inputB: 0,
			lineTracerState: 0
		};
		var motoring = {
			module: 'hamster',
			map: 0xfc000000,
			leftWheel: 0,
			rightWheel: 0,
			buzzer: 0,
			outputA: 0,
			outputB: 0,
			leftLed: 0,
			rightLed: 0,
			note: 0,
			lineTracerMode: 0,
			lineTracerSpeed: 5,
			ioModeA: 0,
			ioModeB: 0
		};
		var boardCommand = 0;
		var boardState = 0;
		var boardCount = 0;
		var timeouts = [];
		
		var removeTimeout = function(id) {
			clearTimeout(id);
			var index = timeouts.indexOf(id);
			if(index >= 0) {
				timeouts.splice(index, 1);
			}
		};
		
		var removeAllTimeouts = function() {
			for(var i in timeouts) {
				clearTimeout(timeouts[i]);
			}
			timeouts = [];
		};
		
		var setLeftLed = function(color) {
			motoring.leftLed = color;
			motoring.map |= 0x01000000;
		};
		
		var setRightLed = function(color) {
			motoring.rightLed = color;
			motoring.map |= 0x00800000;
		};
		
		var setNote = function(note) {
			motoring.note = note;
			motoring.map |= 0x00400000;
		};
		
		var setLineTracerMode = function(mode) {
			motoring.lineTracerMode = mode;
			motoring.map |= 0x00200000;
		};
		
		var reset = function() {
			motoring.map = 0xfde00000;
			motoring.leftWheel = 0;
			motoring.rightWheel = 0;
			motoring.buzzer = 0;
			motoring.outputA = 0;
			motoring.outputB = 0;
			motoring.leftLed = 0;
			motoring.rightLed = 0;
			motoring.note = 0;
			motoring.lineTracerMode = 0;
			motoring.lineTracerSpeed = 5;
			motoring.ioModeA = 0;
			motoring.ioModeB = 0;
			boardCommand = 0;
			boardState = 0;
			boardCount = 0;
			removeAllTimeouts();
		};
		
		var moveForward = function() {
			setLineTracerMode(0);
			boardCommand = 1;
			boardState = 1;
			boardCount = 0;
			motoring.leftWheel = 45;
			motoring.rightWheel = 45;
		};
		
		var turnLeft = function() {
			setLineTracerMode(0);
			boardCommand = 2;
			boardState = 1;
			boardCount = 0;
			motoring.leftWheel = -45;
			motoring.rightWheel = 45;
		};
		
		var turnRight = function() {
			setLineTracerMode(0);
			boardCommand = 3;
			boardState = 1;
			boardCount = 0;
			motoring.leftWheel = 45;
			motoring.rightWheel = -45;
		};
		
		var beep = function() {
			motoring.buzzer = 440;
			setNote(0);
			var timer = setTimeout(function() {
				motoring.buzzer = 0;
				removeTimeout(timer);
				extension.doAfterCommand();
			}, 200);
			timeouts.push(timer);
		};
		
		var beep2 = function() {
			motoring.buzzer = 1000;
			setNote(0);
			var timer = setTimeout(function() {
				motoring.buzzer = 0;
				removeTimeout(timer);
				extension.doAfterCommand();
			}, 200);
			timeouts.push(timer);
		};
		
		var getColor = function(command) {
			var color = command[2];
			color = color.toLowerCase();
			var index = color.lastIndexOf('_');
			if(index > 0) {
				var prefix = color.substring(0, index + 1);
				if(color.indexOf('red') > -1 || color.indexOf('빨간색') > -1 || color.indexOf('빨강색') > -1) {
					command[2] = prefix + 'red';
					return 4;
				} else if(color.indexOf('yellow') > -1 || color.indexOf('노란색') > -1 || color.indexOf('노랑색') > -1) {
					command[2] = prefix + 'yellow';
					return 6;
				} else if(color.indexOf('green') > -1 || color.indexOf('초록색') > -1 || color.indexOf('녹색') > -1) {
					command[2] = prefix + 'green';
					return 2;
				} else if(color.indexOf('cyan') > -1 || color.indexOf('sky blue') > -1 || color.indexOf('skyblue') > -1 || color.indexOf('하늘색') > -1) {
					command[2] = prefix + 'cyan';
					return 3;
				} else if(color.indexOf('blue') > -1 || color.indexOf('파란색') > -1 || color.indexOf('파랑색') > -1) {
					command[2] = prefix + 'blue';
					return 1;
				} else if(color.indexOf('magenta') > -1 || color.indexOf('purple') > -1 || color.indexOf('보라색') > -1 || color.indexOf('자주색') > -1) {
					command[2] = prefix + 'magenta';
					return 5;
				}
			}
			return 0;
		};
		
		var setColor = function(color) {
			if(color >= 0) {
				setLeftLed(color);
				setRightLed(color);
			}
			extension.doAfterCommand();
		};
		
		var clearColor = function() {
			setLeftLed(0);
			setRightLed(0);
			extension.doAfterCommand();
		};
		
		var handleBoard = function() {
			if(boardCommand == 1) {
				switch(boardState) {
					case 1: {
						if(boardCount < 2) {
							if(sensory.leftFloor < 50 && sensory.rightFloor < 50)
								boardCount ++;
							else
								boardCount = 0;
							var diff = sensory.leftFloor - sensory.rightFloor;
							motoring.leftWheel = 45 + diff * 0.25;
							motoring.rightWheel = 45 - diff * 0.25;
						} else {
							boardCount = 0;
							boardState = 2;
						}
						break;
					}
					case 2: {
						var diff = sensory.leftFloor - sensory.rightFloor;
						motoring.leftWheel = 45 + diff * 0.25;
						motoring.rightWheel = 45 - diff * 0.25;
						boardState = 3;
						var timer = setTimeout(function() {
							boardState = 4;
							removeTimeout(timer);
						}, 250);
						timeouts.push(timer);
						break;
					}
					case 3: {
						var diff = sensory.leftFloor - sensory.rightFloor;
						motoring.leftWheel = 45 + diff * 0.25;
						motoring.rightWheel = 45 - diff * 0.25;
						break;
					}
					case 4: {
						motoring.leftWheel = 0;
						motoring.rightWheel = 0;
						boardCommand = 0;
						boardState = 0;
						extension.doAfterCommand();
						break;
					}
				}
			} else if(boardCommand == 2) {
				switch(boardState) {
					case 1: {
						if(boardCount < 2) {
							if(sensory.leftFloor > 50)
								boardCount ++;
						} else {
							boardCount = 0;
							boardState = 2;
						}
						break;
					}
					case 2: {
						if(sensory.leftFloor < 20) {
							boardState = 3;
						}
						break;
					}
					case 3: {
						if(boardCount < 2) {
							if(sensory.leftFloor < 20)
								boardCount ++;
						} else {
							boardCount = 0;
							boardState = 4;
						}
						break;
					}
					case 4: {
						if(sensory.leftFloor > 50) {
							boardState = 5;
						}
						break;
					}
					case 5: {
						var diff = sensory.leftFloor - sensory.rightFloor;
						if(diff > -15) {
							motoring.leftWheel = 0;
							motoring.rightWheel = 0;
							boardCommand = 0;
							boardState = 0;
							extension.doAfterCommand();
						} else {
							motoring.leftWheel = diff * 0.5;
							motoring.rightWheel = -diff * 0.5;
						}
						break;
					}
				}
			} else if(boardCommand == 3) {
				switch(boardState) {
					case 1: {
						if(boardCount < 2) {
							if(sensory.rightFloor > 50)
								boardCount ++;
						} else {
							boardCount = 0;
							boardState = 2;
						}
						break;
					}
					case 2: {
						if(sensory.rightFloor < 20) {
							boardState = 3;
						}
						break;
					}
					case 3: {
						if(boardCount < 2) {
							if(sensory.rightFloor < 20)
								boardCount ++;
						} else {
							boardCount = 0;
							boardState = 4;
						}
						break;
					}
					case 4: {
						if(sensory.rightFloor > 50) {
							boardState = 5;
						}
						break;
					}
					case 5: {
						var diff = sensory.rightFloor - sensory.leftFloor;
						if(diff > -15) {
							motoring.leftWheel = 0;
							motoring.rightWheel = 0;
							boardCommand = 0;
							boardState = 0;
							extension.doAfterCommand();
						} else {
							motoring.leftWheel = -diff * 0.5;
							motoring.rightWheel = diff * 0.5;
						}
						break;
					}
				}
			}
		};
		
		self.handleSensory = function(data) {
			sensory = data;
			handleBoard();
		};
		
		self.requestMotoring = function() {
			return motoring;
		};
		
		self.clearMotoring = function() {
			motoring.map = 0xfc000000;
		};
		
		self.executeCommand = function(command) {
			switch(command[1]) {
				case 'error':
					error(command[2]);
					//extension.doAfterCommand();
					break;
				case 'move':
					var robot1 = eval('r1');
					var robot = _nowRobot;
					_nowRobot = robot1;
					var clear = front_is_clear();
					_nowRobot = robot1;
					extension.doCommand(command);
					_nowRobot = robot;
					if(clear)
						moveForward();
					else
						extension.doAfterCommand();
					break;
				case 'turn_left':
					var robot = _nowRobot;
					_nowRobot = eval('r1');
					extension.doCommand(command);
					_nowRobot = robot;
					turnLeft();
					break;
				case 'pick_beeper':
					var robot = _nowRobot;
					_nowRobot = eval('r1');
					extension.doCommand(command);
					_nowRobot = robot;
					beep2();
					break;
				case 'put_beeper':
					var robot = _nowRobot;
					_nowRobot = eval('r1');
					extension.doCommand(command);
					_nowRobot = robot;
					beep();
					break;
				case 'set_color':
					var robot = _nowRobot;
					_nowRobot = eval('r1');
					var color = getColor(command);
					extension.doCommand(command);
					_nowRobot = robot;
					setColor(color);
					break;
				case 'clear_color':
					var robot = _nowRobot;
					_nowRobot = eval('r1');
					extension.doCommand(command);
					_nowRobot = robot;
					clearColor();
					break;
				default:
					extension.doCommand(command);
					extension.doAfterCommand();
					break;
			}
		};
		
		self.stopCommand = function() {
			reset();
		};
		
		self.showNotice = function() {
			extension.notice('<p>햄스터 로봇을 말판 위에 올려 놓아 주세요.</p><p>말판은<br/>http://hamster.school/ko/tutorial/playbot<br/>에서 내려 받을 수 있습니다.</p><p>r1 로봇에 대해 아래의 함수를 사용하면<br/>햄스터 로봇과 화면의 r1 로봇이 연동되어 같이 움직입니다.<br/>비퍼를 줍거나 내려 놓을 때는 소리가 납니다.</p><p><center><table><tr><td style="text-align:right">move()</td><td style="text-align:left">: 말판 위에서 앞으로 한 칸 이동하기</td></tr><tr><td style="text-align:right">turn_left()</td><td style="text-align:left">: 말판 위에서 왼쪽으로 90도 돌기</td></tr><tr><td style="text-align:right">set_color(색상)</td><td style="text-align:left">: 양쪽 LED를 입력한 색으로 켜기</td></tr><tr><td style="text-align:right">clear_color()</td><td style="text-align:left">: 양쪽 LED 끄기</td></tr></table></center></p>');
		};
	}
	
	function TurtleRobot() {
		var self = this;
		var sensory = {
			map: 0,
			signalStrength: 0,
			colorRed: 0,
			colorGreen: 0,
			colorBlue: 0,
			colorClear: 0,
			floor: 0,
			accelerationX: 0,
			accelerationY: 0,
			accelerationZ: 0,
			temperature: 0,
			button: 0,
			colorNumber: -1,
			colorPattern: -1,
			pulseCount: 0,
			wheelState: 0,
			soundState: 0,
			lineTracerState: 0
		};
		var motoring = {
			module: 'turtle',
			map: 0xf8000000,
			leftWheel: 0,
			rightWheel: 0,
			ledRed: 0,
			ledGreen: 0,
			ledBlue: 0,
			buzzer: 0,
			pulse: 0,
			note: 0,
			sound: 0,
			lineTracerMode: 0,
			lineTracerGain: 5,
			lineTracerSpeed: 5,
			lamp: 1,
			lock: 0,
			motionType: 0,
			motionUnit: 0,
			motionSpeed: 0,
			motionValue: 0,
			motionRadius: 0
		};
		var COLOR_CUSTOM = [0, 0, 0];
		var COLOR_BLACK = [0, 0, 0];
		var COLOR_RED = [255, 0, 0];
		var COLOR_ORANGE = [255, 63, 0];
		var COLOR_YELLOW = [255, 255, 0];
		var COLOR_GREEN = [0, 255, 0];
		var COLOR_SKY_BLUE = [0, 255, 255];
		var COLOR_BLUE = [0, 0, 255];
		var COLOR_VIOLET = [63, 0, 255];
		var COLOR_PURPLE = [255, 0, 255];
		
		var setPulse = function(pulse) {
			motoring.pulse = pulse;
			motoring.map |= 0x04000000;
		};
		
		var setNote = function(note) {
			motoring.note = note;
			motoring.map |= 0x02000000;
		};
		
		var setSound = function(sound) {
			motoring.sound = sound;
			motoring.map |= 0x01000000;
		};
		
		var setLineTracerMode = function(mode) {
			motoring.lineTracerMode = mode;
			motoring.map |= 0x00800000;
		};
		
		var setMotion = function(type, unit, speed, value, radius) {
			motoring.motionType = type;
			motoring.motionUnit = unit;
			motoring.motionSpeed = speed;
			motoring.motionValue = value;
			motoring.motionRadius = radius;
			motoring.map |= 0x00040000;
		};
		
		var reset = function() {
			motoring.map = 0xff840000;
			motoring.leftWheel = 0;
			motoring.rightWheel = 0;
			motoring.ledRed = 0;
			motoring.ledGreen = 0;
			motoring.ledBlue = 0;
			motoring.buzzer = 0;
			motoring.pulse = 0;
			motoring.note = 0;
			motoring.sound = 0;
			motoring.lineTracerMode = 0;
			motoring.lineTracerGain = 5;
			motoring.lineTracerSpeed = 5;
			motoring.lamp = 1;
			motoring.lock = 0;
			motoring.motionType = 0;
			motoring.motionUnit = 0;
			motoring.motionSpeed = 0;
			motoring.motionValue = 0;
			motoring.motionRadius = 0;
		};
		
		var moveForward = function() {
			motoring.leftWheel = 0;
			motoring.rightWheel = 0;
			setPulse(0);
            setLineTracerMode(0);
			setMotion(1, 1, 0, 12, 0);
		};
		
		var turnLeft = function() {
			motoring.leftWheel = 0;
			motoring.rightWheel = 0;
			setPulse(0);
            setLineTracerMode(0);
			setMotion(3, 1, 0, 90, 0);
		};
		
		var turnRight = function() {
			motoring.leftWheel = 0;
			motoring.rightWheel = 0;
			setPulse(0);
            setLineTracerMode(0);
			setMotion(4, 1, 0, 90, 0);
		};
		
		var beep = function() {
			motoring.buzzer = 0;
			setNote(0);
			setSound(1);
		};
		
		var beep2 = function() {
			motoring.buzzer = 0;
			setNote(0);
			setSound(4);
		};
		
		var getColor = function(command) {
			var color = command[2];
			color = color.toLowerCase();
			var index = color.lastIndexOf('_');
			if(index > 0) {
				var prefix = color.substring(0, index + 1);
				var sharp = color.indexOf('#');
				if(sharp > -1) {
					color = color.slice(sharp + 1, sharp + 7);
					if(color.length > 2 && color.length < 6) {
						var str = color.slice(0, 1);
						COLOR_CUSTOM[0] = parseInt(str, 16) * 17;
						str = color.slice(1, 2);
						COLOR_CUSTOM[1] = parseInt(str, 16) * 17;
						str = color.slice(2, 3);
						COLOR_CUSTOM[2] = parseInt(str, 16) * 17;
						return COLOR_CUSTOM;
					} else if(color.length >= 6) {
						var str = color.slice(0, 2);
						COLOR_CUSTOM[0] = parseInt(str, 16);
						str = color.slice(2, 4);
						COLOR_CUSTOM[1] = parseInt(str, 16);
						str = color.slice(4, 6);
						COLOR_CUSTOM[2] = parseInt(str, 16);
						return COLOR_CUSTOM;
					}
				} else if(color.indexOf('red') > -1 || color.indexOf('빨간색') > -1 || color.indexOf('빨강색') > -1) {
					command[2] = prefix + 'red';
					return COLOR_RED;
				} else if(color.indexOf('orange') > -1 || color.indexOf('주황색') > -1) {
					command[2] = prefix + 'orange';
					return COLOR_ORANGE;
				} else if(color.indexOf('yellow') > -1 || color.indexOf('노란색') > -1 || color.indexOf('노랑색') > -1) {
					command[2] = prefix + 'yellow';
					return COLOR_YELLOW;
				} else if(color.indexOf('green') > -1 || color.indexOf('초록색') > -1 || color.indexOf('녹색') > -1) {
					command[2] = prefix + 'green';
					return COLOR_GREEN;
				} else if(color.indexOf('cyan') > -1 || color.indexOf('sky blue') > -1 || color.indexOf('skyblue') > -1 || color.indexOf('하늘색') > -1) {
					command[2] = prefix + 'cyan';
					return COLOR_SKY_BLUE;
				} else if(color.indexOf('blue') > -1 || color.indexOf('파란색') > -1 || color.indexOf('파랑색') > -1) {
					command[2] = prefix + 'blue';
					return COLOR_BLUE;
				} else if(color.indexOf('violet') > -1 || color.indexOf('보라색') > -1) {
					command[2] = prefix + '#3f00ff';
					return COLOR_VIOLET;
				} else if(color.indexOf('magenta') > -1 || color.indexOf('purple') > -1 || color.indexOf('자주색') > -1) {
					command[2] = prefix + 'magenta';
					return COLOR_PURPLE;
				}
			}
			return COLOR_BLACK;
		};
		
		var setColor = function(color) {
			if(color) {
				motoring.ledRed = color[0];
				motoring.ledGreen = color[1];
				motoring.ledBlue = color[2];
			}
			extension.doAfterCommand();
		};
		
		var clearColor = function() {
			motoring.ledRed = 0;
			motoring.ledGreen = 0;
			motoring.ledBlue = 0;
			extension.doAfterCommand();
		};
		
		var handleWheelState = function() {
			if(sensory.map & 0x00000020) {
				if(sensory.wheelState == 0) {
					motoring.leftWheel = 0;
					motoring.rightWheel = 0;
					extension.doAfterCommand();
				}
			}
		};
		
		var handleSoundState = function() {
			if(sensory.map & 0x00000010) {
				if(sensory.soundState == 0) {
					extension.doAfterCommand();
				}
			}
		};
		
		self.handleSensory = function(data) {
			sensory = data;
			handleWheelState();
			handleSoundState();
		};
		
		self.requestMotoring = function() {
			return motoring;
		};
		
		self.clearMotoring = function() {
			motoring.map = 0xf8000000;
		};
		
		self.executeCommand = function(command) {
			switch(command[1]) {
				case 'error':
					error(command[2]);
					//extension.doAfterCommand();
					break;
				case 'move':
					var robot1 = eval('r1');
					var robot = _nowRobot;
					_nowRobot = robot1;
					var clear = front_is_clear();
					_nowRobot = robot1;
					extension.doCommand(command);
					_nowRobot = robot;
					if(clear)
						moveForward();
					else
						extension.doAfterCommand();
					break;
				case 'turn_left':
					var robot = _nowRobot;
					_nowRobot = eval('r1');
					extension.doCommand(command);
					_nowRobot = robot;
					turnLeft();
					break;
				case 'pick_beeper':
					var robot = _nowRobot;
					_nowRobot = eval('r1');
					extension.doCommand(command);
					_nowRobot = robot;
					beep2();
					break;
				case 'put_beeper':
					var robot = _nowRobot;
					_nowRobot = eval('r1');
					extension.doCommand(command);
					_nowRobot = robot;
					beep();
					break;
				case 'set_color':
					var robot = _nowRobot;
					_nowRobot = eval('r1');
					var color = getColor(command);
					extension.doCommand(command);
					_nowRobot = robot;
					setColor(color);
					break;
				case 'clear_color':
					var robot = _nowRobot;
					_nowRobot = eval('r1');
					extension.doCommand(command);
					_nowRobot = robot;
					clearColor();
					break;
				default:
					extension.doCommand(command);
					extension.doAfterCommand();
					break;
			}
		};
		
		self.stopCommand = function() {
			reset();
		};
		
		self.showNotice = function() {
			extension.notice('<p>r1 로봇에 대해 아래의 함수를 사용하면<br/>거북이 로봇과 화면의 r1 로봇이 연동되어 같이 움직입니다.<br/>비퍼를 줍거나 내려 놓을 때는 소리가 납니다.</p><p><center><table><tr><td style="text-align:right">move()</td><td style="text-align:left">: 앞으로 12cm 이동하기</td></tr><tr><td style="text-align:right">turn_left()</td><td style="text-align:left">: 왼쪽으로 90도 돌기</td></tr><tr><td style="text-align:right">set_color(색상)</td><td style="text-align:left">: 머리 LED를 입력한 색으로 켜기</td></tr><tr><td style="text-align:right">clear_color()</td><td style="text-align:left">: 머리 LED 끄기</td></tr></table></center></p>');
		};
	}
	
	function __Runner() {
		var STATE = {
			CONNECTING: 1,
			CONNECTED: 2,
			CONNECTION_LOST: 3,
			DISCONNECTED: 4,
			CLOSED: 5
		};
		var self = this;
		var robots = {};
		var robot = undefined;
		var socket = undefined;
		var alive = false;
		var module = undefined;
		var connectionState = STATE.CONNECTING;
		
		robots['hamster'] = new HamsterRobot();
		robots['turtle'] = new TurtleRobot();
		
		self.open = function(url) {
			if('WebSocket' in window) {
				try {
					var sock = new WebSocket(url);
					sock.binaryType = 'arraybuffer';
					socket = sock;
					sock.onopen = function() {
						sock.onmessage = function(message) { // message: MessageEvent
							try {
								var data = JSON.parse(message.data);
								if(data.module != module) {
									if(robot) robot.stopCommand();
									module = data.module;
									robot = robots[module];
									if(robot) robot.showNotice();
								}
								if(robot) {
									if(data.type == 1) {
										robot.handleSensory(data);
									} else if(data.type == 0) {
										connectionState = data.state;
									}
								}
							} catch (e) {
							}
						};
						sock.onclose = function() {
							alive = false;
							connectionState = STATE.CLOSED;
						};
						
						if(!Date.now) {
							Date.now = function() {
								return new Date().getTime();
							};
						}
						
						var targetTime = Date.now();
						var run = function() {
							if(alive && socket) {
								if(robot && Date.now() > targetTime) {
									try {
										var json = JSON.stringify(robot.requestMotoring());
										if(alive && socket) socket.send(json);
										robot.clearMotoring();
									} catch (e) {
									}
									targetTime += 20;
								}
								setTimeout(run, 5);
							}
						};
						
						alive = true;
						run();
					};
					return true;
				} catch (e) {
				}
			}
			return false;
		};
		
		self.close = function() {
			alive = false;
			if(socket) {
				socket.close();
				socket = undefined;
			}
		};
		
		self.stopCommand = function() {
			if(robot) robot.stopCommand();
		};
		
		self.executeCommand = function(command) {
			if(robot) {
				robot.executeCommand(command);
			} else {
				extension.doCommand(command);
				extension.doAfterCommand();
			}
		};
	};
	var __runner = new __Runner();
	
	if(!extension.executeRobotOriginal && extension.executeRobot)
		extension.executeRobotOriginal = extension.executeRobot;
	if(!extension.stopRobotOriginal && extension.stopRobot)
		extension.stopRobotOriginal = extension.stopRobot;
	if(!extension.runRobotOriginal && extension.runRobot)
		extension.runRobotOriginal = extension.runRobot;
	
	extension.executeRobot = function() {
		__runner.stopCommand();
		extension.executeRobotOriginal();
	};
	
	extension.stopRobot = function(str) {
		extension.stopRobotOriginal(str);
		switch(str) {
			case 'endcmd':
			case 'error':
				break;
			default:
				__runner.stopCommand();
				break;
		}
	};
	
	extension.doCommand = function(command) {
		runRobot_branch();
	};
	
	extension.doAfterCommand = function() {
		var command = _cmd[_cmdindex];
		if(command) {
			if (!_fastmode) {
				if ((command[1] == "show_message") || (command[1] == "say") || (command[1] == "show_chart")) {
					_cmdindex++;
				} else if ((command[1] == "change_speed") && (command[2] == -1)) {
					_cmdindex++;
					_delayID = setTimeout(extension.runRobot, 0);
				} else {
					_cmdindex++;
					_delayID = setTimeout(extension.runRobot, _delayTime);
				}
			} else {
				if ((command[1] == "show_message") || (command[1] == "say") || (command[1] == "show_chart")) {
					_cmdindex++;
					extension.breakWhile = true;
				} else if ((command[1] == "change_speed") && (command[2] > -1)) {
					extension.breakWhile = true;
				} else {
					_cmdindex++;
				}
			}
		}
	};
	
	extension.runRobot = function() {
		if (_limitcnt == 5000) {
			print_action("주의 : 무한반복에 빠지는 코드입니다");
			_limitcnt = 0;
		}
		if (!_fastmode) {
			if (_cmdindex == _cmds) {
				if (_cmds == 0) {
					extension.stopRobot("endcmd");
				} else if (_nowRobot.state) {
					extension.stopRobot("endcmd");
				}
			} else {
				while ((_cmdindex != _cmds) && (eval(_cmd[_cmdindex][0]).state == 0)) {
					_cmdindex++;
				}
				if(_cmd[_cmdindex][0] == 'r1') {
					_nowRobot = eval(_cmd[_cmdindex][0]);
					if (_nowRobot.state) {
						__runner.executeCommand(_cmd[_cmdindex]);
					} else {
						extension.doAfterCommand();
					}
				} else {
					runRobot_branch();
					extension.doAfterCommand();
				}
			}
		} else {
			while (_cmdindex <= _cmds-1) {
				if(_cmd[_cmdindex][0] == 'r1') {
					_nowRobot = eval(_cmd[_cmdindex][0]);
					if (_nowRobot.state) {
						__runner.executeCommand(_cmd[_cmdindex]);
					} else {
						extension.doAfterCommand();
					}
				} else {
					runRobot_branch();
					extension.doAfterCommand();
				}
				if(extension.breakWhile) {
					extension.breakWhile = false;
					break;
				}
			}
			if ((_cmd[_cmdindex][1] == "change_speed") && (_cmd[_cmdindex][2] > -1)) {
				_cmdindex++;
				extension.runRobot();
			}
			if (_cmdindex == _cmds) {
				extension.stopRobot("endcmd");
			}
		}
	};
	
	extension.codeblock_add_hamster = function() {
		if (_playbotmode=="") {
			switch ($(this).text()) {
				case ("햄스터 명령어"):
					var cb = "";
					cb += "<ul class='line1'>";
					cb += "<li class='cb c9' m='<b>move()</b> : 말판 위에서 앞으로 한 칸 이동하기'>move()</li>";
					cb += "<li class='cb c9' m='<b>turn_left()</b> : 말판 위에서 왼쪽으로 90도 돌기'>turn_left()</li>";
					cb += "<li class='cb c9' m='<b>set_color(색상)</b> : 양쪽 LED를 입력한 색으로 켜기<br/>색상 : &#39;빨간색&#39;, &#39;노란색&#39;, &#39;초록색&#39;, &#39;하늘색&#39;, &#39;파란색&#39;, &#39;자주색&#39;, &#39;red&#39;, &#39;yellow&#39;, &#39;green&#39;, &#39;sky blue&#39;, &#39;blue&#39;, &#39;purple&#39;'>set_color()</li>";
					cb += "<li class='cb c9' m='<b>clear_color()</b> : 양쪽 LED 끄기'>clear_color()</li>";
					cb += "</ul>";
					
					$("#cb").children().remove();
					$("#cb").append(cb);
					$(".cb").unbind("click");
					$(".cb").bind("click", codeblock_use);
					$(".cb").mouseover(function () {
						$("#cbtext").html($(this).attr("m"));
					});
					$(".cb").mouseout(function () {
						$("#cbtext").html("&nbsp;");
					});
					break;
			}
		}
	};
	
	extension.codeblock_add_turtle = function() {
		if (_playbotmode=="") {
			switch ($(this).text()) {
				case ("거북이 명령어"):
					var cb = "";
					cb += "<ul class='line1'>";
					cb += "<li class='cb c10' m='<b>move()</b> : 앞으로 12cm 이동하기'>move()</li>";
					cb += "<li class='cb c10' m='<b>turn_left()</b> : 왼쪽으로 90도 돌기'>turn_left()</li>";
					cb += "<li class='cb c10' m='<b>set_color(색상)</b> : 머리 LED를 입력한 색으로 켜기<br/>색상 : &#39;빨간색&#39;, &#39;주황색&#39;, &#39;노란색&#39;, &#39;초록색&#39;, &#39;하늘색&#39;, &#39;파란색&#39;, &#39;보라색&#39;, &#39;자주색&#39;, &#39;red&#39;, &#39;orange&#39;, &#39;yellow&#39;, &#39;green&#39;, &#39;sky blue&#39;, &#39;blue&#39;, &#39;violet&#39;, &#39;purple&#39;, &#39;#rgb&#39; 및 &#39;#rrggbb&#39; 형식'>set_color()</li>";
					cb += "<li class='cb c10' m='<b>clear_color()</b> : 머리 LED 끄기'>clear_color()</li>";
					cb += "</ul>";
					
					$("#cb").children().remove();
					$("#cb").append(cb);
					$(".cb").unbind("click");
					$(".cb").bind("click", codeblock_use);
					$(".cb").mouseover(function () {
						$("#cbtext").html($(this).attr("m"));
					});
					$(".cb").mouseout(function () {
						$("#cbtext").html("&nbsp;");
					});
					break;
			}
		}
	};
	
	extension.displayCodeBlock = function(temp) {
		hide_btn_str();
		if (temp == "reset") {
			$("#cblist").css("z-index", 0);
			closeCodeBlock();
		} else {
			if ($("#cblist").css("display") == "none") {
				if ($("#codearea").css("display") == "none") {
					hideCodeArea();
				}
				openCodeBlock();
			} else {
				closeCodeBlock();
			}
		}
		
		function closeCodeBlock() {
			$("#cblist").slideUp("slow");
		}
		
		function openCodeBlock() {
			var cbg = "";
			if (_playbotmode=="") {
				cbg = str_cbg1;
				cbg += "<li class='cbg hamster c9'>햄스터 명령어</li>";
				cbg += "<li class='cbg turtle c10'>거북이 명령어</li>";
			} else if (_playbotmode=="pjs") {
				cbg = str_cbg2;
			} else if (_playbotmode=="turtle") {
				cbg = str_cbg3;
			} else {
				cbg = str_cbg4;
			}
			$("#cblist").css("z-index", 15);
			$("#cblist").children().remove();
			$("#cblist").append(str_cbg_box);
			$("#cbg").append(cbg);
			$(".cbg").unbind("click");
			$(".cbg").bind("click", codeblock_add);
			
			if (_playbotmode=="") {
				$(".hamster").unbind("click");
				$(".hamster").bind("click", extension.codeblock_add_hamster);
				$(".turtle").unbind("click");
				$(".turtle").bind("click", extension.codeblock_add_turtle);
			}
			
			codeblock_add();
			$("#cblist").slideDown("slow");
			codeblock_resize();
		}
		initWindowSize();
	};
	
	$('#cb_more').unbind('click');
	$('#cbbtn').unbind('click');
	$('#cb_more').bind('click', extension.displayCodeBlock);
	$('#cbbtn').bind('click', extension.displayCodeBlock);
	
	$("#executeBtn").unbind('click');
	$("#executeBtn").unbind('contextmenu');
	$("#stopBtn").unbind('click');
	$("#executeBtn").bind('click', function() {
		if (_playbotmode=="problem") {
			change_speed_action(0);
		}
		extension.executeRobot();
	});
	$("#executeBtn").bind('contextmenu', function() {
		change_speed_action(10);
		extension.executeRobot();
	});
	$("#stopBtn").bind("click", extension.stopRobot);
	
	__runner.open('ws://localhost:53417');
	
	window.alert = extension.notice;
}